# Retrieve a specific proposal version

Use the **getProposalVersion** method via SOAP API 6.0 to retrieve a specific proposal version.

## Request parameters

| Parameters          | Type    | Required/Optional | Description              |
| ------------------- | ------- | ----------------- | ------------------------ |
| **proposalId**      | String  | Required          | The proposal identifier. |
| **proposalVersion** | Integer | Required          | The proposal version.    |

### Request sample

```php
<?php
declare(strict_types=1);

class Configuration
{
    public const MERCHANT_CODE = '';
    public const MERCHANT_KEY = '';
    public const URL = 'http://api.2checkout.com/soap/6.0';
    public const ACTION = 'getProposalVersion';
    public const ADDITIONAL_OPTIONS = null;
    public const PROPOSAL_ID = "7ee02473-b60a-415b-90ae-87c6c443f684";
    public const PROPOSAL_VERSION = 3;
    //array or JSON
    public const PAYLOAD = <<<JSON
    {
    }
JSON;
}

class Client
{
    public function call(
        string $url = Configuration::URL,
        $payload = Configuration::PAYLOAD,
        string $action = Configuration::ACTION,
        string $proposalId = Configuration::PROPOSAL_ID,
        int $proposalVersion = Configuration::PROPOSAL_VERSION
    ): ?object {
        if (is_array($payload)) {
            $payload = json_encode($payload);
        }
        if (!empty($payload)) {
            // SoapClient works with objects(StdClass)
            $payload = json_decode($payload);
        }

        $soapClient = $this->getClient($url);
        $sessionId = $this->getSession($soapClient);
        $args = array_filter([$sessionId, $proposalId, $proposalVersion]);

        return $soapClient->$action(...$args);
    }

    public function getClient(string $url): SoapClient
    {
        return new SoapClient(
            $url.'?wsdl',
            [\
                'location' => $url,\
                'cache_wsdl' => WSDL_CACHE_NONE,\
            ]
        );
    }

    public function getSession(SoapClient $client)
    {
        $date = gmdate('Y-m-d H:i:s');
        $merchantCode = Configuration::MERCHANT_CODE;
        $key = Configuration::MERCHANT_KEY;
        $string = strlen($merchantCode).$merchantCode.strlen($date).$date;
        $hash = hash_hmac('md5', $string, $key);
        $client->__setCookie('XDEBUG_SESSION', 'PHPSTORM');

        return $client->login($merchantCode, $date, $hash);
    }
}

try {
    $client = new Client();
    var_dump($client->call());
} catch (Exception $ex) {
    var_dump($ex);
}
```

## Response

The **getProposalVersion** call via SOAP API 6.0 returns the [Proposal object](/soap-api-reference/soap-api-6.0/api-requests/proposal-microservice.md).


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.2checkout.com/soap-api-reference/soap-api-6.0/api-requests/proposal-microservice/retrieve-a-specific-proposal-version.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
